
#include <stdio.h>
#include <time.h>
#include <unistd.h>
#include <stdlib.h>
#include "dutycycle.h"

int getsleeptimes(int dutycycle,
	int offtime,
	int *sleepHourStart,
	int *sleepMinStart,
	int *sleepHourEnd,
	int *sleepMinEnd)
{
	// Job here is to map the sleephour start and end to the top
	// of the hour
	// note: in this case we ignore argv[8] and argv[9] if they're there
	time_t nowt;
	struct tm * nowst;	
	time ( &nowt );
	nowst = localtime ( &nowt );	   
	if (nowst->tm_min==0 && nowst->tm_sec==0) {
		// just in case we're *exactly* at the topofthehour :-)
		sleep(1);
	}
	struct tm topofthehour;
	topofthehour=*nowst;
	topofthehour.tm_min=0;
	topofthehour.tm_sec=0;
	struct tm nextoffstart=topofthehour;
	nextoffstart.tm_min=dutycycle;
	time_t os=mktime(&nextoffstart);
	while (os<nowt) os+=60*dutycycle;
	struct tm *ost=localtime(&os);
	*sleepHourStart=ost->tm_hour;
	*sleepMinStart=ost->tm_min;
	
	time_t oe=os+60*offtime;
	struct tm *oet=localtime(&oe);
	*sleepHourEnd=oet->tm_hour;
	*sleepMinEnd=oet->tm_min;
	

	return(0);
}

#ifdef UNITTEST
int main(int argc, char *argv[])
{
	// test getsleeptimes
	int dc=atoi(argv[1]);
	int ot=atoi(argv[2]);
	int shs=0,sms=0,she=0,sme=0;
	int ret=getsleeptimes(dc,ot,&shs,&sms,&she,&sme);
	
	printf("dc=%d,ot=%d,start=%02d:%02d,end=%02d:%02d\n",
		dc,ot,shs,sms,she,sme);
	return(0);
}
#endif
